﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace Album_Fotos
{
    public partial class Imagem : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            //verifica se existe uma querystring valida
            if (!string.IsNullOrEmpty(Request.QueryString["id"].ToString()))
            {
                //conecta com o banco de dados
                SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConexaoSQLFotos"].ConnectionString);

                //seleciona uma imagem
                SqlCommand cmd = new SqlCommand("SELECT * FROM Fotos WHERE id=@ImgId", conn);
                cmd.CommandType = CommandType.Text;

                //inclui o id da imagem obtido da query string
                cmd.Parameters.AddWithValue("@ImgId", Request.QueryString["id"]);

                using (conn)
                {
                    //abra a conexão
                    conn.Open();
                    //evia a consulta para selecionar a imagem 
                    SqlDataReader rdr = cmd.ExecuteReader();
                    //le os dados
                    if (rdr.Read())
                    {
                        //armazena os dados binarios em um byte array
                        byte[] imgDados = (byte[])rdr["imagem"];
                        //exibe a imagem
                        Response.ContentType = rdr["tipo"].ToString();
                        Response.OutputStream.Write(imgDados, 0, imgDados.Length);
                    }
                }
            }
        }
    }
}