﻿using System;
using System.Web;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace Album_Fotos
{
    public partial class Incluir : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {}

        protected void calFoto_SelectionChanged(object sender, EventArgs e)
        {
            //exxibe a nova data selecionada no textbox
            txtData.Text = calFoto.SelectedDate.ToShortDateString();
        }

        protected void cusVal_ServerValidate(object source, ServerValidateEventArgs args)
        {
            //cria um array de extensões válidas
            string[] validaExtensao = { "jpg", "jpeg", "png", "gif", "bmp" };

            //define args como inválida
            args.IsValid = false;

            //pega o nome do arquivo
            string nomeArquivo = fupFoto.PostedFile.FileName;

            //verifica se a string não é vazia
            if (!string.IsNullOrEmpty(nomeArquivo))
            {
                //pega a extensão do arquivo
                string fileExt = nomeArquivo.Substring(nomeArquivo.LastIndexOf('.') + 1).ToLower();
                //verifica se a extensão atual é válida
                for (int i = 0; i < validaExtensao.Length; i++)
                {
                    if (fileExt == validaExtensao[i]) //se for valida
                        args.IsValid = true;          //valida
                }
            }
        }

        protected void btnEnviar_Click(object sender, EventArgs e)
        {
            //verifica se o arquivo selecionado foi selecionado
            if (fupFoto.PostedFile != null && !string.IsNullOrEmpty(fupFoto.PostedFile.FileName) && cusVal.IsValid)
            {
                //cria um array de bytes para armazenar os dados da imagem
                byte[] imgFoto = new byte[fupFoto.PostedFile.ContentLength];
                //armazena o arquivo selecionado na memória
                HttpPostedFile img = fupFoto.PostedFile;
                //define os dados binários
                img.InputStream.Read(imgFoto, 0, (int)fupFoto.PostedFile.ContentLength);

                //conecta com o banco de dados
                SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConexaoSQLFotos"].ConnectionString);

                //salva a imagem no banco de dados
                SqlCommand cmd = new SqlCommand("INSERT INTO Fotos(imagem, tamanho, tipo, data, mensagem) VALUES (@imagem, @tamanho, @tipo, @data, @mensagem)", conn);
                cmd.CommandType = CommandType.Text;

                //inclui os dados binários
                cmd.Parameters.Add("@imagem", SqlDbType.Image, imgFoto.Length).Value = imgFoto;
                //inclui o tamanho da imagem
                cmd.Parameters.AddWithValue("@tamanho", imgFoto.Length);
                //inclui o tipo da imagem
                cmd.Parameters.AddWithValue("@tipo", fupFoto.PostedFile.ContentType);
                //inclui a data dataa
                cmd.Parameters.AddWithValue("@data", DateTime.Parse(txtData.Text));
                //inclui uma mensagem
                cmd.Parameters.AddWithValue("@mensagem", txtMensagem.Text);

                using (conn)
                {
                    //abre a conexão 
                    conn.Open();
                    //envia a consulta SQL para o banco de dados
                    cmd.ExecuteNonQuery();
                }
                lblmsg.Text = " Imagem enviado com sucesso...";
            }
            else
            {
                lblmsg.Text = "Informações inválidas...";
            }
        }

        protected void btnRetornar_Click(object sender, EventArgs e)
        {
            Response.Redirect("Default.aspx");
        }
    }
}